<?
// $RCSfile: dvp_config.inc,v $
// $Revision: 1.1 $
// $Name: dvpbrowse-1_0_0-1 $
// $Date: 2008/09/04 16:00:45 $
// $Author: agibert $

/*--------------------------------------------------------------------------------------------------------------------*/
/* Path and URL definitions                                                                                           */
/*--------------------------------------------------------------------------------------------------------------------*/

$dvp_path="/var/httpd/www.rx3.org/html/dvp";
$dvp_url="/dvp/";
$dvp_header="/var/httpd/www.rx3.org/html/dvp/header.html";
$dvp_footer="/var/httpd/www.rx3.org/html/dvp/footer.html";
$dvp_download_http_url="/dvp/download";
$dvp_download_ftp_url="ftp://ftp.rx3.org/pub/arc/dvp";
$dvp_cvsweb_url="/cgi-bin/viewcvs.cgi";
$dvp_freshmeat_url="http://freshmeat.net/projects";



/*--------------------------------------------------------------------------------------------------------------------*/
/* Keywords definitions                                                                                               */
/*--------------------------------------------------------------------------------------------------------------------*/

$dvp_keywords="rx3,rx3.org,rx3 developement,rx3 cvs,cvs,free software,open source,download";



/*--------------------------------------------------------------------------------------------------------------------*/
/* Development Application definitions                                                                                */
/*--------------------------------------------------------------------------------------------------------------------*/

$dvp_tab=array( "java_tools" => array ( "name" => "Java Tools",
					"dvp"  => array ( "mqsload"     => array( "name"        => "MQSLoad",
										  "summary"     => "A simple tool to load messages from a file into a MQSeries queue",
										  "description" => "MQSLoad is a simple java program which load messages red from a file into a MQSeries queue.",
										  "depend"      => "",
										  "listbrk"     => "no",
										  "freshmeat"   => "yes"
										  ),
							 "mqssave"      => array( "name"        => "MQSSave",
										  "summary"     => "A simple tool to save messages from a MQSeries queue into a file",
										  "description" => "MQSSave is a simple java program which save messages red from a MQSeries queue into a file.",
										  "depend"      => "",
										  "listbrk"     => "no",
										  "freshmeat"   => "yes"
										  ),
							 "tslaunch"     => array( "name"        => "TSLaunch",
										  "summary"     => "A command launcher with a command line timestamp generation",
										  "description" => "TSLaunch is simple java program which launch a sub-command whom some args are completed whith a timestamp. ",
										  "depend"      => "",
										  "listbrk"     => "yes",
										  "freshmeat"   => "no"
										  )
							 )
					),

		"lib_prj"    => array ( "name" => "Librarie Dev Projects",
					"dvp"  => array ( "libver"      => array( "name"        => "LibVer",
										  "summary"     => "A runtime module versioning manager C library",
										  "description" => "LibVer is a C library which manages enbeded version string into object files.",
										  "depend"      => "",
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  ),

							  "libopt"      => array( "name"        => "LibOpt",
										  "summary"     => "A generic program option (cmd line / ini file / internal) manager C library",
										  "description" => "LibOpt is a C library which manages options which can be setup internaly, in a .ini file or in the command line.",
										  "depend"      => "",
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  ),

							  "libnode"     => array( "name"        => "LibNode",
										  "summary"     => "A generic list/tree manager C library",
										  "description" => "LibNode is a C library which manages generic list and/or tree node structures.",
										  "depend"      => "",
										  "listbrk"     => "yes",
										  "freshmeat"   => "yes"
										  ),

							  "libshmem"    => array( "name"        => "LibShMem",
										  "summary"     => "A shared memory pool manager C library",
										  "description" => "LibShMem is a C library which manages memory pools in shared memory. It's built over LibNode.",
										  "depend"      => array( "libnode"),
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  ),

							  "libdatastr"  => array( "name"        => "LibDataStr",
										  "summary"     => "An inter-proces generic list/tree manager C library",
										  "description" => "LibDataStr is a C library which manages generic list and/or tree node structures inter-process sharable. It's built over LibNode and libShMem.",
										  "depend"      => array( "libnode", "libshmem"),
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  ),

							  "libmsg"      => array( "name"        => "LibMsg",
										  "summary"     => "An inter-process messaging system C library",
										  "description" => "LibMsg is a C library which manages messages exchange between message ports inter-process sharable. It's built over LibNode, libShMem and libDataStr.",
										  "depend"      => array( "libnode", "libshmem", "libdatastr"),
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  ),

							  "liblog"      => array( "name"        => "LibLog",
										  "summary"     => "A centralized and controled inter-proces log manager C library",
										  "description" => "LibLog is a C library which manages inter-process log in a distributed environment. It's built over LibNode, libShMem, libDataStr and libMsg.",
										  "depend"      => array( "libnode", "libshmem", "libdatastr", "libmsg"),
										  "listbrk"     => "yes",
										  "freshmeat"   => "no"
										  ),

							  "libdatabase" => array( "name"        => "LibDatabase",
										  "summary"     => "An Oracle OCI frontend C library",
										  "description" => "LibDatabase is a C library which offers an interface between Oracle OCI API and a C program.",
										  "depend"      => "",
										  "listbrk"     => "yes",
										  "freshmeat"   => "no"
										  ),
							  )
					),

		"web_prj"    => array ( "name" => "Web Projects",
					"dvp"  => array ( "dvpbrowse"   => array( "name"        => "DvpBrowse",
										  "summary"     => "Development Project Browser",
										  "description" => "DvpBrowse is a small php script which gerates dynamicaly some HTML pages in order to browse a list of development project.<BR>
<BR>
These development projects are grouped by sections. Each project have got a home page which displays some informations (version, summary, ...) and provides some internal and external links (release notes file, readme file, download, cvs browse, freshmeat, ..). The displayed informations are extracted from the configuration file and development tarball.<BR>
<BR>
This script has been made inorder to browse the \"Rx3 Free Software Development Pages\" on http://www.rx3.org.",
										  "depend"      => "",
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  ),
							  "pkgbrowse"   => array( "name"        => "PkgBrowse",
										  "summary"     => "Packaging Project Browser",
										  "description" => "PkgBrowse is a small php script which gerates dynamicaly some HTML pages in order to browse a list of packaging project.<BR>
<BR>
These packaging projects are grouped by sections. Each project have got a home page which displays some informations (version, summary, last change log, sub packages,...) and provides some internal and external links (change log file, file list, download, ..). The displayed informations are extracted from the configuration file and RPM packages.<BR>
<BR>
This script has been made inorder to browse the \"Rx3 Free Software Packaging Pages\" on http://www.rx3.org.",
										  "depend"      => "",
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  )
							  )
					),
		

		"misc_prj"   => array ( "name" => "Misc Dev Projects",
					"dvp"  => array ( "eql_tools"   => array( "name"        => "Eql_Tools",
										  "summary"     => "Linux serial line Eql tools",
										  "description" => "Eql_Tools is a set of tools controling linux serial line network load ballancing.",
										  "depend"      => "",
										  "listbrk"     => "no",
										  "freshmeat"   => "no"
										  )
							  )
					)
		
		);
?>
